import httpRequestApi from '../../../utils/APIClient';
import {
    formatDate
} from '../../../utils/util';
import {
    getOpenidSessionKey
  } from '../../../utils/httpUtil';
const app = getApp()
Page({
    data: {
        fullScreenBtn: false,
        playBtn: true,
        gesture: false,
        author: '',
        videoSrc: '',
        total: '',
        authorAvatar: '',
        user: [],
        inputValue: '',
        inputSBValue: '',
        replyList: [],
        howMuch: '200',
        moneySelect: 'moneySelect',
        moneyNormal: 'moneyNormal',
        ifReward: false,
        id: '',
        path: '',
        replyModal: false,
        totalRead: 0,
        pageNo: 1,
        pageSize: 3,
        goBackHome: false,
        isIOS: app.globalData.isIOS,
        alertFlag: false,
        modalType: "text",
        noScroll: '',
        modalText: [{
                text: '您还不是本课程的会员',
                type: 'bigOrange'
            },
            {
                text: '您可以开团，拼团成功获得使用权',
                type: 'normal'
            }
        ],
        modalBtnText: '去开团',
        isModalShow: false,
        modalCloseShow: true,
        hide: true
        // shareFlag: false
    },
    showAlert: function () {
        this.setData({
            alertFlag: !this.data.alertFlag
        })
    },
    onLoad: function (option) {
        getOpenidSessionKey((res) => {
            let id = option.id ? option.id : option.scene.replace('QR', '')
            if (option.scene || option.shareCard) {
                this.setData({
                    goBackHome: true
                })
            }
            // wx.setNavigationBarTitle({
            //     title: option.title //页面标题为路由参数
            // })
            this.uid = wx.getStorageSync('uid');
            let stackSize = 1;
            if (option.stackSize) {
                stackSize = option.stackSize;
            }
            this.setData({
                // title: option.title,
                id,
                myUid: this.uid,
                stackSize
            })
            this.getWorks(this.uid, id);
        }, (error) => {
            this.setData({
                hide: !this.data.hide,
                onLoadOption: option
            })
            return;
        });
    },
    onHide: function () {
        // this.data.stackSize >= 2
        console.log(this.data.stackSize)
        if (this.innerAudioContext) {
            this.innerAudioContext.pause();
        }
        this.videoCtx = null
    },
    onUnload: function () {
        if (this.innerAudioContext) {
            this.innerAudioContext.destroy();
        }
        this.videoCtx = null
        // let videoCtx = wx.createVideoContext('worksVideo', this);
        // videoCtx.stop();
    },
    getWorks: function (uid, id) {
        httpRequestApi.getWorksDetail(uid, id).success((res) => {
            const others = res.data.data.otherRead;
            const author = res.data.data.user;
            const works = res.data.data.userRead;
            wx.setNavigationBarTitle({
                title: works.title //页面标题为路由参数
            })
            const othersTemp = [];
            others.forEach((item) => {
                const temp = {};
                temp.uid = item.userRead.id;
                temp.title = item.userRead.title;
                temp.image = item.user.avatar;
                temp.nickName = item.user.wechatName;
                othersTemp.push(temp);
            });
            this.setData({
                user: othersTemp,
                totalRead: res.data.data.totalRead,
                author: author.wechatName,
                authorAvatar: author.avatar,
                authorProfession: author.profession,
                authorUid: author.uid,
                videoSrc: works.originVideo,
                audioSrc: works.audioPath,
                iconImg: works.iconImg,
                classId: works.lessonId,
                isLike: res.data.data.isLike,
                isFans: res.data.data.isFans,
                title: works.title
            })
            httpRequestApi.checkLesson(works.lessonId).success(res => {
                const productId = res.data.data[0];
                this.setData({
                    productId
                })
            });
            // 设置音频路径
            this.innerAudioContext = wx.createInnerAudioContext();
            this.innerAudioContext.onPause((res) => {
                // 播放音频失败的回调
                console.log('音频暂停')
            })
            this.innerAudioContext.src = this.data.audioSrc; // 这里可以是录音的临时路径



        });
    },
    onShow() {
        console.log(this.data.stackSize)
        this.setData({
            replyList: [],
            pageNo: 1,
            pageSize: 2
        }, () => {
            this.getReply();
        })
    },
    videoPlayHandler: function () {
        this.setData({
            videoLoad: true
        }, () => {
            this.videoCtx = wx.createVideoContext('worksVideo', this);
            this.videoCtx.play();
        })
    },
    likeWorks: function (e) {
        if (this.data.isLike) {
            wx.showToast({
                title: '不要重复点赞哦',
                icon: 'fail',
                duration: 1000
            })
            return;
        }
        httpRequestApi.likeWorks(this.uid, this.data.id).success(res => {
            this.setData({
                isLike: true
            }, () => {
                wx.showToast({
                    title: '点赞数+1',
                    icon: 'success',
                    duration: 1000
                })
            });
        })

    },
    // 弹出分享框
    openShare: function (e) {
        console.log(this.data.authorAvatar)
        console.log(this.data.author)
        console.log(this.data.iconImg)
        console.log(this.data.title)
        console.log(this.data.id)
        if (this.data.authorAvatar && this.data.author && this.data.iconImg && this.data.title && this.data.id) {
            this.shareDialog = this.selectComponent("#share-dialog");
            const data = {
                avatar: this.data.authorAvatar,
                author: this.data.author,
                iconImg: this.data.iconImg,
                title: this.data.title,
                path: `pages/social/works/works`,
                scene: this.data.id,
                // tip: this.data.tip,
            }
            // console.log(data)
            this.setData({
                noScroll: 'noScroll'
            })
            this.shareDialog.share(data);
        }
    },
    // 分享框关闭
    shareDialogClose: function (e) {
        this.setData({
            noScroll: ''
        })
    },
    videoPlay: function () {
        // 视频开始 先结束 再开始
        // this.innerAudioContext.play();
        // this.innerAudioContext.pause();
        // wx.showToast({
        //     title: '加载中',
        //     icon: 'loading',
        //     duration: 600
        // })
        // setTimeout(() => {
        this.innerAudioContext.play();
        // }, 800)
        httpRequestApi.playWorks(this.uid, this.data.id).success(() => {
            console.log('容个错')
        });
    },
    // 视频播放完毕销毁录音
    videoEnd: function () {
        this.innerAudioContext.stop();
    },
    videoPause: function () {
        console.log('视频暂停')
        this.innerAudioContext.pause();
    },
    videoWaiting: function () {
        console.log('视频缓冲')
        this.innerAudioContext.pause();
    },
    videoProgress: function (e) {
        console.log('视频加载进度变化')
        console.log(e)
        if (e.detail.buffered <= 10) {
            this.innerAudioContext.pause();
        } else {
            this.innerAudioContext.play();
        }
    },
    videoTimeupdate: function (e) {
        console.log('视频播放进度发生变化')
        console.log('视频当前时长', e.detail.currentTime);
        console.log('音频当前时长', this.innerAudioContext.currentTime)
        if (e.detail.currentTime - this.innerAudioContext.currentTime >= 1) {
            this.innerAudioContext.seek(e.detail.currentTime - 0.1);
        }
    },
    goToReading: function () {
        const classId = this.data.classId;


        httpRequestApi.areYouSuper(this.data.productId).success(res => {
            if (res.data.success) {
                wx.navigateTo({
                    url: `../../main/reading/reading?id=${classId}`
                })
            } else {
                // ios用户 并且没有购买过此书
                // if (this.data.isIOS) {
                //     wx.showModal({
                //         title: '暂不支持',
                //         content: '十分抱歉，由于相关规定，您暂时无法在这里朗读',
                //         success(res) {
                //             if (res.confirm) {
                //                 console.log('用户点击确定')
                //             } else if (res.cancel) {
                //                 console.log('用户点击取消')
                //             }
                //         }
                //     })
                //     return;
                // }
                console.log('chulaiba')
                this.setData({
                    isModalShow: true
                })
                // wx.showModal({
                //     title: '您未购买过本书，不能朗读',
                //     content: '超值团购进行中，快去看看',
                //     success(res) {
                //         if (res.confirm) {
                //             console.log('用户点击确定')
                //             wx.navigateTo({
                //                 url: `../../groupPage/grade-details/grade-details?productId=${productId}`
                //             })
                //         } else if (res.cancel) {
                //             console.log('用户点击取消')
                //         }
                //     }
                // })
            }
        })
    },
    onShareAppMessage: function () {
        console.log(this.data.productId);

        return {
            title: '一样的课文，不一样的味道！我的配音表演已开始，求各位大咖围观、点评！',
            path: `pages/social/works/works?id=${this.data.id}&title=${this.data.title}&shareCard=true`,
            imageUrl: `https://efunbox.lingjiao.cn/reader/resource/share/read_${this.data.productId}.jpg`
        }
    },
    follow: function () {
        let followUid = this.data.authorUid;
        if (this.data.isFans) {
            httpRequestApi.cancerFollow(this.uid, followUid).success((res) => {
                this.setData({
                    isFans: false
                })
                wx.showToast({
                    title: '取消关注',
                    icon: 'success',
                    duration: 1000
                })
            });
        } else {
            httpRequestApi.followUser(this.uid, followUid).success((res) => {
                this.setData({
                    isFans: true
                })
                wx.showToast({
                    title: '关注啦',
                    icon: 'success',
                    duration: 1000
                })
            });
        }
    },
    // 点赞评论
    likeCommend: function (e) {
        console.log(e);
        // let uid = wx.getStorageSync('uid');
        let followUid = e.currentTarget.dataset.id;
        let index = e.currentTarget.dataset.index;
        httpRequestApi.likeCommend(this.uid, followUid).success(res => {
            console.log(res);
            const str = `replyList[${index}].likes`;
            const strImg = `replyList[${index}].isLike`;
            this.setData({
                [str]: res.data.data.favors,
                [strImg]: true
            })
        });
    },
    // 去用户主页
    goToUsers: function (e) {
        let uid = e.currentTarget.dataset.uid;
        wx.navigateTo({
            url: `../../user/myworks/myworks?uid=${uid}`
        });
    },
    // 去其他用户的作品页
    goToOthers: function (e) {
        this.data.stackSize++;
        console.log(this.data.stackSize)
        if (this.data.stackSize >= 3) {
            console.log('跳转', this.data.stackSize)
            wx.redirectTo({
                url: `../../social/works/works?id=${e.currentTarget.dataset.uid}&title=${e.currentTarget.dataset.title}&stackSize=${this.data.stackSize}`
            })
        } else {
            console.log('下一个页面', this.data.stackSize)
            wx.navigateTo({
                url: `../../social/works/works?id=${e.currentTarget.dataset.uid}&title=${e.currentTarget.dataset.title}&stackSize=${this.data.stackSize}`
            })
        }

    },
    // 查询回复
    getReply: function () {
        // let uid = wx.getStorageSync('uid');
        let columnId = this.data.id;
        let pageNo = this.data.pageNo;
        let pageSize = this.data.pageSize;
        httpRequestApi.getReply(this.uid, columnId, pageNo, pageSize).success((res) => {
            const replyList = res.data.data.list;
            // const replyTemp = [];
            replyList.forEach((item) => {
                const temp = {};
                temp.nickName = item.user.wechatName;
                temp.avatar = item.user.avatar;
                temp.profession = item.user.profession;
                temp.uid = item.user.uid;
                // temp.text = decodeURI(item.detailDesc);
                temp.text = item.detailDesc;
                temp.id = item.id;
                temp.replyCount = item.replyCount;
                temp.time = formatDate(item.gmtCreated, 3);
                temp.likes = item.postsAttributeInfo.favors || 0;
                temp.isLike = item.isLike;
                this.data.replyList.push(temp);
            });
            this.setData({
                replyList: this.data.replyList,
                total: res.data.data.totalSize,
                totalPage: res.data.data.totalNo
            })
        });
    },
    // 打开回复详情页
    goToDetail: function (e) {
        let id = e.currentTarget.dataset.id;
        // let count = e.currentTarget.dataset.count;
        wx.navigateTo({
            url: `../../social/replyDetail/replyDetail?id=${id}`
        })
    },
    //  绑定输入框内容
    inputValue: function (e) {
        this.setData({
            inputValue: e.detail.value
        });
    },
    // 发布回复
    sendHandler: function () {
        if (this.data.inputValue !== '') {
            // let uid = wx.getStorageSync('uid');
            let data = {
                "columnId": this.data.id,
                colunmNames: 'what',
                // "detailDesc": encodeURI(this.data.inputValue)
                "detailDesc": this.data.inputValue
            }
            httpRequestApi.postReply(this.uid, data).success(res => {
                this.setData({
                    inputValue: '',
                    pageNo: 1,
                    replyList: [],
                })
                this.getReply();
            });
            // 评论成功后刷新数据

        }
    },
    // 触底加载
    onReachBottom: function () {
        // 当前在推荐页面 加载推荐
        if (this.data.pageNo <= this.data.totalPage) {
            this.setData({
                pageNo: this.data.pageNo + 1
            }, () => {
                this.getReply();
            })
        }


    },
    // 设置点击时的id
    setSBId: function (e) {
        this.setData({
            replySBId: e.currentTarget.dataset.id,
            replyModal: true,
            replyIndex: e.currentTarget.dataset.index
        })
    },
    // 回复某个评论
    replySB: function () {
        const data = {
            postsId: this.data.replySBId,
            content: this.data.inputSBValue
        }
        httpRequestApi.postReplyComment(this.uid, data).success(res => {
            const replyWho = this.data.replyList[this.data.replyIndex];
            const indexStr = `replyList[${this.data.replyIndex}]`;
            replyWho.replyCount++;
            this.setData({
                replyModal: false,
                [indexStr]: replyWho
            })
        });
    },
    // 获取回复楼中楼的内容
    inputSBValue: function (e) {
        this.setData({
            inputSBValue: e.detail.value
        });
    },
    // 选择金额
    setMoney: function (e) {
        this.setData({
            howMuch: e.currentTarget.dataset.money
        })
    },
    reward: function () {
        if(this.data.isIOS){
            return 
        };
        this.setData({
            ifReward: true
        })
    },
    quitReward: function () {
        this.setData({
            ifReward: false
        })
    },
    // 奖励
    rewardMoney: function () {
        const data = {
            targetUid: this.data.authorUid,
            amount: this.data.howMuch
        }
        // let uid = wx.getStorageSync('uid');
        httpRequestApi.rewardMoney(this.uid, data).success(res => {
            if (res.data.message) {
                wx.showModal({
                    title: '提示',
                    content: res.data.message,
                    success(res) {
                        if (res.confirm) {
                            console.log('用户点击确定')
                        } else if (res.cancel) {
                            console.log('用户点击取消')
                        }
                    }
                })
                return false;
            }
            this.payMoney(res.data.data);
        })

    },
    //支付
    payMoney: function (orderInfo) {
        if (this.data.haveTapMoney) {
            return false
        }
        this.setData({
            haveTapMoney: true
        })
        wx.requestPayment({
            'appId': orderInfo.appId,
            'timeStamp': orderInfo.timeStamp,
            'nonceStr': orderInfo.nonceStr,
            'package': orderInfo.package,
            'signType': orderInfo.signType,
            'paySign': orderInfo.sign,
            'success': res => {
                this.setData({
                    modalType: 'image',
                    isModalShow: true,
                    modalCloseShow: false,
                    modalBtnText: '确定',
                    haveTapMoney: false,
                    ifReward: false
                })
                // wx.showModal({
                //     title: '提示',
                //     content: '支付成功',
                //     success(res) {
                //         if (res.confirm) {
                //             this.setData({
                //                 ifReward: false
                //             })
                //         } else if (res.cancel) {
                //             this.setData({
                //                 ifReward: false
                //             })
                //         }
                //     }
                // })

            },
            'fail': res => {
                this.setData({
                    haveTapMoney: false,
                })
                console.log('支付失败', res)
            }
        })
    },
    // 回到首页
    goBackHome: function () {
        wx.redirectTo({
            url: '../../index/index'
        })
    },
    modalConfirmHandler: function () {

        if (this.data.modalType === 'image') {
            this.setData({
                modalType: 'text',
                isModalShow: false,
                ifReward: false,
                modalCloseShow: true,
                modalBtnText: "去开团",
                // ifReward: false
            })
            return false
        }
        this.setData({
            isModalShow: false
        })
        wx.navigateTo({
            url: `../../groupPage/grade-details/grade-details?productId=${this.data.productId}`
        })
    },
    modalCloseHandler: function () {
        this.setData({
            isModalShow: false
        })
    },
    jurisdiction: function () {
        //隐藏弹框
        this.setData({
            hide: !this.data.hide
        })
        //登录页信息
        this.onLoad(this.data.onLoadOption);
    },
})